;started 1/12/2016


	PRGCOUNT = 1;
	CHRCOUNT = 1;
	MAPPER = 0;
	MIRRORING = %0001
	
	.db "NES",$1A
	.db PRGCOUNT
	.db CHRCOUNT
	.db MAPPER|MIRRORING
	.dsb 9,$00
	
	
	.enum $0000
	room_ptr			.dsb 2	;pointer for the rooms. Each room could have up to 8 screens, but for now, it's fixed at 4 screens exactly
	column_ptr			.dsb 2	;pointer for the columns of the rooms. There are 16 columns per screen * 4 screens = 
	ppuaddr_ptr			.dsb 2	;The high and low bytes to put in $2006 when drawing shite
	source_ptr			.dsb 2	;Once the room and column is found, this loads the bytes in the column which correspond to indexes for metatiles
	metatile_bank_ptr	.dsb 2	;which metatile bank to choose from (Only 1 right now)
	metatile_ptr		.dsb 2	;Address of the metatile chosen
	jump_ptr			.dsb 2	;Used for indirect jumps
	buffer_ptr			.dsb 2	;Right now there are 2 buffers, so this keeps the address of which buffer to load from
	.ende
	.enum $0010
	MTColumn_buffer1	.dsb 30	;The two buffers for holding the actual tiles that make up the metatile
	MTColumn_buffer2	.dsb 30	;
	sleeping			.dsb 1	;Done with frame code, waiting for VBlank to happen?
	nmi_enabled			.dsb 1	;Set to 0 when bulk drawing, 1 any other time
	room				.dsb 1	;the index for which "Room" we're in
	column				.dsb 1	;the column number currently being loaded
	scroll				.dsb 1	;This essentially acts as a shadow for $2005. Stuff is done to it during the frame, and it is then stored in $2005 during NMI
	nametable			.dsb 1	;If we're drawing to PPU $2000 or $2400
	repeat_meta_tile	.dsb 1	;If the RLE compression roudine is currently in progress
	data_x				.dsb 1	;Used for loading metatiles
	data_y				.dsb 1	;Used for loading metatiles
	needcolumnbufferupdate	.dsb 1	;If a buffer update is needed
	whichbuffer			.dsb 1	;The first or second buffer?
	buttons				.dsb 1	;
	buttons_old			.dsb 1	;Controller stuff
	buttons_pressed		.dsb 1	;
	drawingmode			.dsb 1	;0 - drawing directly to PPU, 1 - Drawing to buffer
	screen				.dsb 1	;UNUSED
	intromovingcount	.dsb 1	;set to 3 to move 3 pixels at startup so the screen won't flash at the beginning (This needs to be fixed)
	.ende
	.enum $0300
	global_x			.dsb 2	;These -+
	global_y			.dsb 2	;Are	+____ My next step is figuring out how to move sprites in relation to a screen that appears to be moving
	local_x				.dsb 1	;Un		+
	local_y				.dsb 1	;Used --+
	.ende
	
	MAXSCREEN		= 3			;__ eventually will be determined in room data so rooms can be different sizes. Unused for now
	MINSCREEN		= 4			;
	
	
	.base $C000
RESET:
	sei
	cld
	ldx #$40
	stx $4017
	ldx #$FF
	txs
	inx
	stx $2000
	stx $2001
	stx $4010
VBlWait1:
	bit $2002
	bpl VBlWait1

ClrMem:				;X is at 0
	lda #$00
	sta $00,x
	sta $0100,x
	sta $0300,x
	sta $0400,x
	sta $0500,x
	sta $0600,x
	sta $0700,x
	lda #$FE
	sta $0200,x
	inx
	bne ClrMem
VBlWait2:
	bit $2002
	bpl VBlWait2
	
	
LoadPalette:
	;(modify to load multiple palettes)
	lda $2002
	lda #$3F
	sta $2006
	lda #$00
	sta $2006
	ldx #$00
-	lda Palette,x
	sta $2007
	inx
	cpx #32
	bne -
	
	;(load sprites would go here)
	
	;drawing mode should be at 0, initially we draw directly to the PPU to fill up the first screen
	
LoadTestScreen:
	;Fill up the first screen with tiles
	lda #$01
	sta nametable		;gets XORd to 0 in the subroutine that's coming up
	lda #$00
	sta scroll
	sta column
-	jsr DrawNewColumn
	lda scroll
	clc
	adc #16
	sta scroll
	inc column
	lda column
	cmp #16				;load 16
	bne -
	
	;draw the first column of the next screen
	lda #$00
	sta nametable		;gets XORd to 1 in the following subroutine
	;sta scroll
	inc drawingmode					;these are drawn to the buffer to set it up so it wont shoot out zeros.
	jsr DrawNewColumn
	inc column
	lda #$01						;Let the NMI know it needs to draw this to the PPU
	sta needcolumnbufferupdate
	lda scroll						;find out where to draw
	lsr
	lsr
	lsr
	sta ppuaddr_ptr+0
	lda nametable
	eor #$01
	asl
	asl
	clc
	adc #32
	sta ppuaddr_ptr+1
	
	lda #$00
	sta $2000						;Set back to horizontal drawing mode
	
	;initialize attributes
	;Load the 2 attribute tables ($23C0 and $27C0) with #$00
	lda $2002
	lda #$23
	sta $2006
	lda #$C0
	sta $2006
	ldx #64
	lda #$00
-	sta $2007
	dex
	bne -
	lda #$27
	sta $2006
	lda #$C0
	sta $2006
	ldx #64
	lda #$00
--	sta $2007
	dex
	bne --
	
	lda #$03
	sta intromovingcount		;scroll to the left for 3 frames at startup
	
	lda #$01
	sta nmi_enabled
	lda #%10010000
	sta $2000
	lda #%00011110
	sta $2001
	
	
MainLoop:
	inc sleeping
@waitframe:
	lda sleeping
	bne @waitframe
	
	;The first 3 frames at startup, the screen moves. This just prevents it from flashing at the beginning until I figure out how to fix it
MoveScreenAtStartup:
	lda intromovingcount
	beq MoveScreenDone
	inc scroll
	dec intromovingcount
MoveScreenDone:
	
	jsr ReadControllers
		
ReadLeft:
	lda buttons
	and #%00000010
	beq ReadLeftDone
	dec scroll
	;update 16-bit global x
;	lda global_x+0
;	sec
;	sbc #$01
;	bcs +
;	lda global_x+1
;	sec
;	sbc #$01
;	and #%00000011
;	sta global_x+1
;	lda #$FF
;+	sta global_x+0
ReadLeftDone:
ReadRight:
	lda buttons
	and #%00000001
	beq ReadRightDone
	inc scroll
	;update 16-bit global x
;	lda global_x+0
;	clc
;	adc #$01
;	bcc +
;	lda global_x+1
;	clc
;	adc #$01
;	and #%00000011
;	sta global_x+1
;	lda #$00
;+	sta global_x+0
ReadRightDone:
	
NTSwapCheck:		;checks if the scroll has gotten to a new screen, in which case it's time to switch nametables
	lda scroll
	bne NTSwapCheckDone
	lda screen
	clc
	adc #$01
	and #%00000011	;4 screens
	sta screen
	lda nametable
	eor #$01
	sta nametable
NTSwapCheckDone:

BufferCheck:		;see if a buffer update needs to happen. (Every 8 pixels)
	lda scroll
	and #%00000111
	bne BufferCheckDone
	lda #$01
	sta needcolumnbufferupdate
	lda scroll
	and #%00001000				;only worried about the 4th bit, we'll see if we need to load from the first or second buffer
	lsr
	lsr
	lsr
	sta whichbuffer
	lda scroll					;find out where to draw
	lsr
	lsr
	lsr
	sta ppuaddr_ptr+0
	lda nametable
	eor #$01
	asl
	asl
	clc
	adc #32
	sta ppuaddr_ptr+1
BufferCheckDone:

NewColumnCheck:					;see if it's time to draw the next column to the buffer
	lda scroll
	and #%00001111
	bne NewColumnCheckDone
	jsr DrawNewColumn
	lda column
	clc
	adc #$01
	and #%0111111				;will wrap around after 128, giving us 4 rooms for right now.
	sta column
NewColumnCheckDone:

	jmp MainLoop
	
	
NMI:
	pha
	txa
	pha
	tya
	pha
	
	lda nmi_enabled
	beq SkipNMI					;if in the middle of bulk-drawing, skip NMI, don't turn PPU back on (It should be shut off)
	
UpdateColumns:
	lda needcolumnbufferupdate	;There could probably be a more efficient and/or optimized buffer unloading routine, but it's within VBlank time so it's okay for now
	beq UpdateColumnsDone
	lda whichbuffer
	asl
	tax
	lda Buffers,x
	sta buffer_ptr+0
	lda Buffers+1,x
	sta buffer_ptr+1
	;unload bytes from the buffer to the PPU
	lda #%00000100
	sta $2000
	lda $2002
	;(Eventually, figure out if moving left or right, for now, just right)
	lda ppuaddr_ptr+1
	sta $2006
	lda ppuaddr_ptr+0
	sta $2006
	ldx #30
	ldy #0
-	lda (buffer_ptr),y
	sta $2007
	iny
	dex
	bne -
	lda #$00
	sta needcolumnbufferupdate
UpdateColumnsDone:

	;normal NMI stuff
	
	;Sprites which we don't have (yet)
	
	lda #$00
	sta $2003
	lda #$02
	sta $4014
	
	;other graphics code
	
	lda #$00
	sta $2006
	sta $2006
	
	lda scroll
	sta $2005
	lda #$00
	sta $2005
	
	lda #%10010000
	ora nametable			;get the right base nametable address
	sta $2000
	lda #%00011110
	sta $2001
SkipNMI:
	;(run music engine)
	dec sleeping
	
	pla
	tay
	pla
	tax
	pla
	rti
	
	
ReadControllers:
	ldx buttons
	stx buttons_old
	ldx #$01
	stx $4016
	dex
	stx $4016
	ldx #$08
-	lda $4016
	lsr
	rol buttons
	dex
	bne -
	lda buttons_old
	eor #$FF
	and buttons
	sta buttons_pressed
	rts
	
DrawingModes:
	.dw MTDecompress, MTDecompressToBuffer		;Jump table to indirect jump to the right routine whether we're drawing directly to the PPU or to the buffer
	
DrawNewColumn:
	;just a long metatile and RLE decompression routine. Not super important.
	lda room				;Get the right room
	asl
	tax
	lda RoomColumns,x
	sta room_ptr+0
	lda RoomColumns+1,x
	sta room_ptr+1
	
	lda column				;Get the right column
	asl
	tay
	lda (room_ptr),y
	sta source_ptr+0
	iny
	lda (room_ptr),y
	sta source_ptr+1
	
	lda drawingmode			;Get the right drawing mode
	asl
	tax
	lda DrawingModes,x
	sta jump_ptr+0
	lda DrawingModes+1,x
	sta jump_ptr+1
	
	lda drawingmode
	bne +			;don't set up PPU if just drawing to the buffer
	lda scroll		;Figure out where to draw
	lsr
	lsr
	lsr
	sta ppuaddr_ptr+0
	lda nametable
	eor #$01
	asl
	asl
	clc
	adc #32
	sta ppuaddr_ptr+1
	
	lda #%00000100	;Vertical drawing mode
	sta $2000
	
	lda $2002
	lda ppuaddr_ptr+1
	sta $2006
	lda ppuaddr_ptr+0
	sta $2006
+	ldx #$00
	stx data_x
	ldy #$00
	sty data_y
StartDrawing:
	lda repeat_meta_tile
	beq @jump
	dec repeat_meta_tile
	jmp (jump_ptr)			;Go straight to the decompression routine if still unloading repeated tiles
@jump:
	ldy data_y
	lda (source_ptr),y
	cmp #$FF
	bne @next
	jmp MTLoadingDone		;Exit routine if we get to #$FF which means no more metatiles
@next:
	lda (source_ptr),y
	and #%10000000
	bne @next1
	jmp @loadtile
@next1:
	lda (source_ptr),y
	and #%01000000
	bne @next2
	jmp @repeat
@next2:						;if both bit 6 and 7 are set, time to switch metatile banks
	lda (source_ptr),y
	and #%00111111
	asl
	tax
	lda MTBanks,x
	sta metatile_bank_ptr
	lda MTBanks+1,x
	sta metatile_bank_ptr+1
	iny
	sty data_y
	jmp StartDrawing
@repeat:					;otherwise if just bit 7 is set, repeat metatiles (Can encode up to 16 bytes, but all we gotta worry about is 15)
	lda (source_ptr),y
	and #%00111111
	sta repeat_meta_tile
	iny
	sty data_y
@loadtile:					;Use the byte as an index to find which metatile to decompress
	lda (source_ptr),y
	iny
	sty data_y
	asl
	tay
	lda (metatile_bank_ptr),y
	sta metatile_ptr
	iny
	lda (metatile_bank_ptr),y
	sta metatile_ptr+1
	jmp (jump_ptr)
	
MTDecompress:				;decompress and draw directly to the PPU
	ldy #$00
	ldx data_x
	lda (metatile_ptr),y
	sta $2007
	iny
	lda (metatile_ptr),y
	sta $2007
	iny
	lda (metatile_ptr),y
	sta MTColumn_buffer1,x	;This is kinda confusing, but the second half of the metatiles are drawn to the buffer, which are then drawn to the PPU once the first half has been drawn
	iny
	inx
	lda (metatile_ptr),y
	sta MTColumn_buffer1,x
	inx
	stx data_x
	cpx #30					;once all 30 tiles have been drawn, time to draw the second half of the metatiles
	beq @next
	jmp StartDrawing
@next:
	lda #$00
	sta $2007
	sta $2007				;skip over the nonvisible part of the screen (Actually its where the attributes would be)
	inc ppuaddr_ptr+0		;inc the high byte of the address being given to $2006. For whatever reason this seems necessary in vertical drawing mode
	lda $2002
	lda ppuaddr_ptr+1
	sta $2006
	lda ppuaddr_ptr+0
	sta $2006
	ldy #$00
DrawSecondHalf:
	lda MTColumn_buffer1,y	;unload the second half of the metatiles (Which are in the buffer) to the PPU
	sta $2007
	iny
	cpy #30
	bne DrawSecondHalf
	ldx #$00
	stx data_x
	lda #$00
	sta $2007
	sta $2007
	jmp StartDrawing
MTLoadingDone:
	rts
	
MTDecompressToBuffer:	;draws to the buffer rather than directly to the PPU
	ldy #$00
	ldx data_x
	lda (metatile_ptr),y
	sta MTColumn_buffer1,x		;draw the first half to buffer 1
	iny
	lda (metatile_ptr),y
	sta MTColumn_buffer1+1,x	;
	iny
	lda (metatile_ptr),y
	sta MTColumn_buffer2,x		;draw the second half to buffer 2
	iny
	lda (metatile_ptr),y
	sta MTColumn_buffer2+1,x	;
	inx
	inx
	stx data_x
	cpx #30
	beq MTLoadingDone
	jmp StartDrawing
	
	
	.org $E000
Buffers:
	.dw MTColumn_buffer1, MTColumn_buffer2
	
Palette:
	.db $21,$00,$10,$30, $21,$17,$37,$27, $21,$06,$18,$29, $21,$21,$21,$21			;background
	.db $21,$0F,$36,$15, $21,$0F,$36,$15, $21,$0F,$36,$15, $21,$0F,$36,$15			;sprite
	

MTBanks:
	.dw MTBank0
	
MTBank0:
	.dw MTB0_0, MTB0_1
	
MTB0_0:
	.db $40,$50,$41,$51
MTB0_1:
	.db $24,$24,$24,$24

	
RoomColumns:
	.dw Room0Columns
	

;column data for rooms
Room0Columns:
	.dw Room0Screen0Column0,Room0Screen0Column1, Room0Screen0Column1,Room0Screen0Column1, Room0Screen0Column1,Room0Screen0Column2, Room0Screen0Column3,Room0Screen0Column4	;Screen0
	.dw Room0Screen0Column4,Room0Screen0Column2, Room0Screen0Column2,Room0Screen0Column1, Room0Screen0Column1,Room0Screen0Column1, Room0Screen0Column1,Room0Screen0Column0	;
	.dw Room0Screen0Column0,Room0Screen0Column1, Room0Screen0Column1,Room0Screen0Column1, Room0Screen0Column1,Room0Screen1Column0, Room0Screen1Column1,Room0Screen1Column2	;Screen1
	.dw Room0Screen1Column3,Room0Screen1Column4, Room0Screen1Column5,Room0Screen0Column1, Room0Screen0Column1,Room0Screen0Column1, Room0Screen0Column1,Room0Screen0Column0	;
	.dw Room0Screen0Column0,Room0Screen0Column1, Room0Screen0Column1,Room0Screen0Column1, Room0Screen0Column1,Room0Screen2Column0, Room0Screen2Column1,Room0Screen2Column2	;Screen2
	.dw Room0Screen2Column3,Room0Screen2Column4, Room0Screen2Column5,Room0Screen0Column1, Room0Screen0Column1,Room0Screen0Column1, Room0Screen0Column1,Room0Screen0Column0	;
	.dw Room0Screen0Column0,Room0Screen0Column1, Room0Screen0Column1,Room0Screen0Column1, Room0Screen0Column1,Room0Screen3Column0, Room0Screen3Column1,Room0Screen3Column2	;Screen3
	.dw Room0Screen3Column3,Room0Screen3Column3, Room0Screen3Column4,Room0Screen0Column1, Room0Screen0Column1,Room0Screen0Column1, Room0Screen0Column1,Room0Screen0Column0	;
	
	
Room0Screen0Column0:
	.db %11000000
	.db $8E,$00
	.db $FF
Room0Screen0Column1:
	.db %11000000
	.db $00,$8C,$01,$00
	.db $FF
Room0Screen0Column2:
	.db %11000000
	.db $00,$89,$01,$00,$01,$01,$00
	.db $FF
Room0Screen0Column3:
	.db %11000000
	.db $00,$83,$01,$00,$84,$01,$00,$01,$01,$00
	.db $FF
Room0Screen0Column4:
	.db %11000000
	.db $00,$82,$01,$87,$00,$01,$01,$00
	.db $FF
	
Room0Screen1Column0:
	.db %11000000
	.db $00,$83,$01,$00,$84,$01,$00,$01,$01,$00
	.db $FF
Room0Screen1Column1:
	.db %11000000
	.db $00,$82,$01,$00,$00,$83,$01,$00,$00,$01,$01,$00
	.db $FF
Room0Screen1Column2:
	.db %11000000
	.db $00,$82,$01,$00,$83,$01,$82,$00,$01,$01,$00
	.db $FF
Room0Screen1Column3:
	.db %11000000
	.db $00,$82,$01,$00,$82,$01,$00,$00,$01,$00,$01,$01,$00
	.db $FF
Room0Screen1Column4:
	.db %11000000
	.db $00,$82,$01,$84,$00,$01,$01,$00,$01,$01,$00
	.db $FF
Room0Screen1Column5:
	.db %11000000
	.db $00,$83,$01,$82,$00,$82,$01,$00,$01,$01,$00
	.db $FF

Room0Screen2Column0:
	.db %11000000
	.db $00,$82,$01,$00,$85,$01,$00,$01,$01,$00
	.db $FF
Room0Screen2Column1:
	.db %11000000
	.db $00,$82,$01,$00,$01,$01,$00,$82,$01,$00,$01,$01,$00
	.db $FF
Room0Screen2Column2:
	.db %11000000
	.db $00,$82,$01,$00,$01,$00,$00,$82,$01,$00,$01,$01,$00
	.db $FF
Room0Screen2Column3:
	.db %11000000
	.db $00,$82,$01,$83,$00,$01,$01,$00,$00,$01,$01,$00
	.db $FF
Room0Screen2Column4:
	.db %11000000
	.db $00,$82,$01,$00,$00,$01,$83,$00,$82,$01,$00
	.db $FF
Room0Screen2Column5:
	.db %11000000
	.db $00,$82,$01,$00,$82,$01,$00,$00,$83,$01,$00
	.db $FF
	
Room0Screen3Column0:
	.db %11000000
	.db $00,$85,$01,$82,$00,$83,$01,$00
	.db $FF
Room0Screen3Column1:
	.db %11000000
	.db $00,$84,$01,$00,$01,$00,$00,$83,$01,$00
	.db $FF
Room0Screen3Column2:
	.db %11000000
	.db $00,$83,$01,$00,$01,$01,$00,$00,$83,$01,$00
	.db $FF
Room0Screen3Column3:
	.db %11000000
	.db $00,$82,$01,$87,$00,$01,$01,$00
	.db $FF
Room0Screen3Column4:
	.db %11000000
	.db $00,$86,$01,$00,$00,$83,$01,$00
	.db $FF
	
	
	.org $FFFA
	.dw NMI
	.dw RESET
	.dw 0
	
	.incbin "grafks.chr"